#include <stdio.h>
#include <graphics.h>
#include <math.h>

//előrejelzett függvények
void page(int*);
void mozog(int*, int, int, int, int, int);

//fő függvény
int main()
{
    int gd = EGA, gm = EGAHI, hibakod, aktiv_lap;
    initgraph(&gd, &gm, NULL);
    hibakod = graphresult();

    if (hibakod)
    {
        printf("Grafikus hiba: %s", grapherrormsg(hibakod));
        exit(1);
    }

    cleardevice();
    setvisualpage(0);

    aktiv_lap = 1;
    setactivepage(1);
    cleardevice();

    setbkcolor(BLUE);
    mozog(&aktiv_lap, 100, 100, 500, 300, 30);
    mozog(&aktiv_lap, 500, 300, 100, 100, 10);
    mozog(&aktiv_lap, 500, 100, 100, 300, 10);
    mozog(&aktiv_lap, 100, 300, 500, 100, 10);
    mozog(&aktiv_lap, 100, 100, 100, 300, 10);
    mozog(&aktiv_lap, 100, 300, 100, 100, 10);
    mozog(&aktiv_lap, 100, 100, 500, 300, 30);
    mozog(&aktiv_lap, 500, 300, 100, 100, 10);
    closegraph();
    return 0;
}

void page(int* aktiv_lap)
{
    setvisualpage(*aktiv_lap);

    *aktiv_lap = 1 - *aktiv_lap;
    setactivepage(*aktiv_lap);
    cleardevice();
}

void mozog(int* aktiv_lap, int x0, int y0, int x1, int y1, int v0)
{
    int vx, vy, t, x, y;
    double dx, dy, s0;

    dx = (double)(x1 - x0); //x irányú elmozdulás
    dy = (double)(y1 - y0); //y irányú elmozdulás
    s0 = sqrt(dx * dx + dy * dy); //megtett út, Pitagorasz-tételéből

    vx = (int)(v0 * dx / s0 + 0.5); //x irányú sebesség a v0-ból - úgy aránylik mint dx:s0-hoz
    vy = (int)(v0 * dy / s0 + 0.5); //x irányú sebesség a v0-ból - úgy aránylik mint dy:s0-hoz

    //alaphelyzet:
    t = 0; //eltelt idő
    x = x0; //x irányú koordináta
    y = y0; //y irányú koordináta

    do
    {
        //rajzolás (x, y pontba)
        setcolor(RED);
        circle(x + 2, y + 3, 12);
        fillellipse(x, y, 30, 5);
        line(x - 10, y - 10, x + 2, y + 3);
        line(x + 10, y - 10, x + 2, y + 3);

        //lapváltás
        page(aktiv_lap);

        //számolás
        x = x0 + t * vx; //x mozgatása, vx sebességgel
        y = y0 + t * vy; //y mozgatása, vy sebességgel
        delay(20); //0,02 másodpercet vár
        t++; //az eltelt idő növelése
    }
    while ((abs(t * vx) < abs(dx)) && (abs(t * vy) < abs(dy)));
    /* addig csinálja, amíg egyik irányban sem haladja meg az
      elmozdulás a megadott dx, dy értékeket */
}
